﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Word = Microsoft.Office.Interop.Word;

namespace СУБД_Швейная_фабрика
{
    public partial class fManager : Form
    {
        public fManager()
        {
            InitializeComponent();
        }

        private void usersBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.usersBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.garmentFactoryDataSet);

        }

        private void fManager_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "garmentFactoryDataSet.Products". При необходимости она может быть перемещена или удалена.
            this.productsTableAdapter.Fill(this.garmentFactoryDataSet.Products);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "garmentFactoryDataSet.Users". При необходимости она может быть перемещена или удалена.
            this.usersTableAdapter.Fill(this.garmentFactoryDataSet.Users);
            FillListZakaz();

            GetTkaniFromDB();
            FillLVTkani();
            GetFurnituraFromDB();
            FillLVFurnitura();
        }
        void FillListZakaz()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            string TxtQuery =
@"select Products.Name as Prod, Orders.ProductsCount as ProductsCount, 
Fabrics.Name as fabric, Furnitura.namefur as fur, Orders.FurnitureCount as FurnitureCount, 
Users.Surname as manager
from Orders, Users, Fabrics, Furnitura, Products
where Users.User_id = Orders.Manager_id and Fabrics.Fabric_id = Orders.Fabric_id 
and Furnitura.idfur = Orders.idfur and Products.Product_id = Orders.Product_id
and Orders.Manager_id = " + LblIdManager.Text;

            SqlCommand query1 = new SqlCommand(TxtQuery, con);
            // выполнить запрос
            SqlDataReader SqlRez = query1.ExecuteReader();

            DgvZakaz.Rows.Clear(); // очистить от старых строк
            // перебирать результаты запроса
            while (SqlRez.Read())
            {
                DgvZakaz.Rows.Add(SqlRez["Prod"], SqlRez["ProductsCount"],
                    SqlRez["fabric"], SqlRez["fur"], SqlRez["FurnitureCount"],
                    SqlRez["manager"]);
            }
            con.Close();
        }



        public struct Tkani
        {
            public string IdTkan, NameTkan, ColorTkan, Width, Length, Description;
            public Image PhotoTkan;
        }

        List<Tkani> LstTkani = new List<Tkani>();

        /// <summary>
        /// получить из базы данных сведения о тканях
        /// </summary>
        void GetTkaniFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Fabrics where length > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Tkani Tk = new Tkani();
                Tk.IdTkan = Data["Fabric_id"].ToString();
                Tk.NameTkan = Data["Name"].ToString();
                Tk.ColorTkan = Data["Color"].ToString();
                Tk.Width = Data["Width"].ToString();
                Tk.Length = Data["Length"].ToString();
                Tk.Description = Data["Comment"].ToString();
                try
                {
                    // загрузить из таблицы БД байты фотографии в массив
                    byte[] PhotoByte = (byte[])Data["Photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    // сконвертировать массив байт в изображение
                    Tk.PhotoTkan = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    // в случае ошибки загрузить пустое изображение из ресурсов
                    Tk.PhotoTkan = Properties.Resources.tmp;
                }
                LstTkani.Add(Tk);  // добавить в список новую ткань
            }
            con.Close();
        }

        /// <summary>
        /// заполнение таблицы с фотографиями тканей
        /// </summary>
        void FillLVTkani()
        {
            LVTkani.Items.Clear();
            ImageListTkani.Images.Clear();
            foreach (Tkani Tk in LstTkani)
            {
                // новый элемент для ListView с названием ткани
                ListViewItem LV = new ListViewItem(Tk.NameTkan);
                // в ImageList добавить изображение ткани
                ImageListTkani.Images.Add(Tk.PhotoTkan);
                // связать последнее добавленное изображение с новым элементом ListView
                LV.ImageIndex = ImageListTkani.Images.Count - 1;
                LVTkani.Items.Add(LV);  // добавить новый элемент к ListView
            }
        }



        public struct Furnitura
        {
            public string IdFur, NameFur, CountFur;
            public Image PhotoFur;
        }

        List<Furnitura> LstFurnitura = new List<Furnitura>();

        /// <summary>
        /// получить данные о фурнитурах из базы данных
        /// </summary>
        void GetFurnituraFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Furnitura where countfur > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Furnitura Fr = new Furnitura();
                Fr.IdFur = Data["idfur"].ToString();
                Fr.NameFur = Data["namefur"].ToString();
                Fr.CountFur = Data["countfur"].ToString();
                try
                {
                    // загрузить из таблицы БД байты фотографии в массив
                    byte[] PhotoByte = (byte[])Data["photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    // сконвертировать массив байт в изображение
                    Fr.PhotoFur = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    // в случае ошибки загрузить пустое изображение из ресурсов
                    Fr.PhotoFur = Properties.Resources.tmp;
                }
                LstFurnitura.Add(Fr);  // добавить в список новую фурнитуру
            }
            con.Close();
        }

        /// <summary>
        /// заполнить таблицу с фотографиями фурнитур
        /// </summary>
        void FillLVFurnitura()
        {
            LVFurnitura.Items.Clear();
            ImageListFur.Images.Clear();
            foreach (Furnitura Fr in LstFurnitura)
            {
                // новый элемент для ListView с названием фурнитуры
                ListViewItem LV = new ListViewItem(Fr.NameFur);
                // в ImageList добавить изображение фурнитуры
                ImageListFur.Images.Add(Fr.PhotoFur);
                // связать последнее добавленное изображение с новым элементом ListView
                LV.ImageIndex = ImageListFur.Images.Count - 1;
                LVFurnitura.Items.Add(LV);  // добавить новый элемент к ListView
            }
        }

        private void BtnProfile_Click(object sender, EventArgs e)
        {
            fProfile fProfile = new fProfile();
            // на форму для редактирования профиля передать 
            // фильтр для выборки авторизовавшегося пользователя
            fProfile.usersBindingSource.Filter = this.usersBindingSource.Filter;
            if (fProfile.ShowDialog() == DialogResult.OK)
            {
                this.usersTableAdapter.Fill(this.garmentFactoryDataSet.Users);
            }
        }

        private void BtnAdd_Click(object sender, EventArgs e)
        {
            productsBindingSource.AddNew();
            BtnSave.Enabled = true;
            BtnAdd.Enabled = false;
            BtnEdit.Enabled = false;
            DgvIzd.Enabled = false;
            TbxNameIzd.Enabled = true;
            TbxLengthIzd.Enabled = true;
            TbxWidthIzd.Enabled = true;
        }

        private void BtnEdit_Click(object sender, EventArgs e)
        {
            BtnSave.Enabled = true;
            BtnAdd.Enabled = false;
            BtnEdit.Enabled = false;
            DgvIzd.Enabled = false;
            TbxNameIzd.Enabled = true;
            TbxLengthIzd.Enabled = true;
            TbxWidthIzd.Enabled = true;
        }

        private void BtnSave_Click(object sender, EventArgs e)
        {
            productsBindingSource.EndEdit();
            this.productsTableAdapter.Update(this.garmentFactoryDataSet.Products);
            BtnSave.Enabled = false;
            BtnAdd.Enabled = true;
            BtnEdit.Enabled = true;
            DgvIzd.Enabled = true;
            TbxNameIzd.Enabled = false;
            TbxLengthIzd.Enabled = false;
            TbxWidthIzd.Enabled = false;
        }

        private void LVTkani_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVTkani.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVTkani.SelectedIndices[0];  // номер выделенного элемента
                NametkanTextBox.Text = LstTkani[num].NameTkan;
                ColorTextBox.Text = LstTkani[num].ColorTkan;
                WidthTextBox.Text = LstTkani[num].Width;
                LengthTextBox.Text = LstTkani[num].Length;
                DescriptionTextBox.Text = LstTkani[num].Description;
            }
            else  // нет выделенных элементов
            {
                NametkanTextBox.Text = "";
                ColorTextBox.Text = "";
                WidthTextBox.Text = "";
                LengthTextBox.Text = "";
                DescriptionTextBox.Text = "";
            }
        }

        private void LVFurnitura_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVFurnitura.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVFurnitura.SelectedIndices[0];  // номер выделенного элемента
                TbxNameFur.Text = LstFurnitura[num].NameFur;
                TbxCountFurSklad.Text = LstFurnitura[num].CountFur;
            }
            else  // нет выделенных элементов
            {
                TbxNameFur.Text = "";
                TbxCountFurSklad.Text = "";
            }
        }

        private void BtnAll_Click(object sender, EventArgs e)
        {

            if (RbtWord.Checked)
            {
                Word.Application app = new Word.Application();
                app.Visible = true;
                Word.Document doc = app.Documents.Open(Application.StartupPath + "\\Заказы.docx", null, true);

                Word.Bookmarks WBmark = doc.Bookmarks;  // закладки из документа
                WBmark["man"].Range.Text = FamLabel.Text + " " + NameLabel.Text + " " + OtchLabel.Text;

                string num = "", izd = "", countizd = "", tkan = "",
                    fur = "", countfur = "", zakazchik = "";
                for (int i = 0; i <= DgvZakaz.RowCount - 1; i++)  // перебор записей в таблице
                {
                    num += (i + 1).ToString() + "." + "\r\n";
                    izd += DgvZakaz.Rows[i].Cells[0].Value + "\r\n";
                    countizd += DgvZakaz.Rows[i].Cells[1].Value + "\r\n";
                    tkan += DgvZakaz.Rows[i].Cells[2].Value + "\r\n";
                    fur += DgvZakaz.Rows[i].Cells[3].Value + "\r\n";
                    countfur += DgvZakaz.Rows[i].Cells[4].Value + "\r\n";
                    zakazchik += DgvZakaz.Rows[i].Cells[5].Value + "\r\n";
                }
                WBmark["num"].Range.Text = num.Trim();
                WBmark["izd"].Range.Text = izd.Trim();
                WBmark["countizd"].Range.Text = countizd.Trim();
                WBmark["tkan"].Range.Text = tkan.Trim();
                WBmark["fur"].Range.Text = fur.Trim();
                WBmark["countfur"].Range.Text = countfur.Trim();
                WBmark["zak"].Range.Text = zakazchik.Trim();
            }
            else
            {
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter f = new StreamWriter(saveFileDialog1.FileName);
                    string t = "izd;countizd;tkan;furnitura;countfur;zakazchik";
                    f.WriteLine(t);

                    for (int i = 0; i <= DgvZakaz.RowCount - 1; i++)
                    {
                        t = "";
                        t += DgvZakaz.Rows[i].Cells[0].Value + ";";
                        t += DgvZakaz.Rows[i].Cells[1].Value + ";";
                        t += DgvZakaz.Rows[i].Cells[2].Value + ";";
                        t += DgvZakaz.Rows[i].Cells[3].Value + ";";
                        t += DgvZakaz.Rows[i].Cells[4].Value + ";";
                        t += DgvZakaz.Rows[i].Cells[5].Value;
                        f.WriteLine(t);
                    }
                    f.Close();
                }
            }
        }

        private void BtnSelect_Click(object sender, EventArgs e)
        {
            if (RbtWord.Checked)
            {
                Word.Application app = new Word.Application();
                app.Visible = true;
                Word.Document doc = app.Documents.Open(Application.StartupPath + "\\Заказы.docx", null, true);

                Word.Bookmarks WBmark = doc.Bookmarks;  // закладки из документа
                WBmark["man"].Range.Text = FamLabel.Text + " " + NameLabel.Text + " " + OtchLabel.Text;

                string num = "", izd = "", countizd = "", tkan = "",
                    fur = "", countfur = "", zakazchik = "";
                for (int i = 0; i <= DgvZakaz.SelectedRows.Count - 1; i++)  // перебор записей в таблице
                {
                    num += (i + 1).ToString() + "." + "\r\n";
                    izd += DgvZakaz.SelectedRows[i].Cells[0].Value + "\r\n";
                    countizd += DgvZakaz.SelectedRows[i].Cells[1].Value + "\r\n";
                    tkan += DgvZakaz.SelectedRows[i].Cells[2].Value + "\r\n";
                    fur += DgvZakaz.SelectedRows[i].Cells[3].Value + "\r\n";
                    countfur += DgvZakaz.SelectedRows[i].Cells[4].Value + "\r\n";
                    zakazchik += DgvZakaz.SelectedRows[i].Cells[5].Value + "\r\n";
                }
                WBmark["num"].Range.Text = num.Trim();
                WBmark["izd"].Range.Text = izd.Trim();
                WBmark["countizd"].Range.Text = countizd.Trim();
                WBmark["tkan"].Range.Text = tkan.Trim();
                WBmark["fur"].Range.Text = fur.Trim();
                WBmark["countfur"].Range.Text = countfur.Trim();
                WBmark["zak"].Range.Text = zakazchik.Trim();
            }
            else
            {
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter f = new StreamWriter(saveFileDialog1.FileName);
                    string t = "izd;countizd;tkan;furnitura;countfur;zakazchik";
                    f.WriteLine(t);

                    for (int i = 0; i <= DgvZakaz.SelectedRows.Count - 1; i++)
                    {
                        t = "";
                        t += DgvZakaz.SelectedRows[i].Cells[0].Value + ";";
                        t += DgvZakaz.SelectedRows[i].Cells[1].Value + ";";
                        t += DgvZakaz.SelectedRows[i].Cells[2].Value + ";";
                        t += DgvZakaz.SelectedRows[i].Cells[3].Value + ";";
                        t += DgvZakaz.SelectedRows[i].Cells[4].Value + ";";
                        t += DgvZakaz.SelectedRows[i].Cells[5].Value;
                        f.WriteLine(t);
                    }
                    f.Close();
                }
            }
        }
    }
}
