﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace СУБД_Швейная_фабрика
{
    public partial class fStorekeeper : Form
    {
        public fStorekeeper()
        {
            InitializeComponent();
        }

        private void rolesBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.tableAdapterManager.UpdateAll(this.garmentFactoryDataSet);

        }

        private void fStorekeeper_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "garmentFactoryDataSet.Users". При необходимости она может быть перемещена или удалена.
            this.usersTableAdapter.Fill(this.garmentFactoryDataSet.Users);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "garmentFactoryDataSet.Roles". При необходимости она может быть перемещена или удалена.
            FillListZakaz();
            GetTkaniFromDB();
            FillLVTkani();
            GetFurnituraFromDB();
            FillLVFurnitura();
        }

        private void usersBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.usersBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.garmentFactoryDataSet);

        }
        void FillListZakaz()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            string txtquery =
@"select Products.Name as Prod, Orders.ProductsCount as ProductsCount, 
Fabrics.Name as fabric, Furnitura.namefur as fur, Orders.FurnitureCount as FurnitureCount, 
UsersMan.Surname as manager, UsersCus.Surname as Customer
from Orders, Users as UsersMan, Users as UsersCus ,Fabrics, Furnitura, Products
where UsersMan.User_id = Orders.Manager_id
and UsersCus.User_id =  Orders.Custmer_id
and Fabrics.Fabric_id = Orders.Fabric_id 
and Furnitura.idfur = Orders.idfur
and Products.Product_id = Orders.Product_id";

            SqlCommand query1 = new SqlCommand(txtquery, con);
            // выполнить запрос
            SqlDataReader sqlrez = query1.ExecuteReader();

            DgvZakaz.Rows.Clear(); // очистить от старых строк
            // перебирать результаты запроса
            while (sqlrez.Read())
            {
                DgvZakaz.Rows.Add(sqlrez["Prod"], sqlrez["ProductsCount"],
                    sqlrez["fabric"], sqlrez["fur"], sqlrez["FurnitureCount"],
                    sqlrez["manager"], sqlrez["Customer"]);
            }
            con.Close();
        }


        public struct Tkani
        {
            public string IdTkan, NameTkan, ColorTkan, Width, Length, Description;
            public Image PhotoTkan;
        }

        List<Tkani> LstTkani = new List<Tkani>();

        /// <summary>
        /// получить из базы данных сведения о тканях
        /// </summary>
        void GetTkaniFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from fabrics where length > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Tkani Tk = new Tkani();
                Tk.IdTkan = Data["Fabric_id"].ToString();
                Tk.NameTkan = Data["Name"].ToString();
                Tk.ColorTkan = Data["Color"].ToString();
                Tk.Width = Data["Width"].ToString();
                Tk.Length = Data["Length"].ToString();
                Tk.Description = Data["Comment"].ToString();
                try
                {
                    // загрузить из таблицы БД байты фотографии в массив
                    byte[] PhotoByte = (byte[])Data["Photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    // сконвертировать массив байт в изображение
                    Tk.PhotoTkan = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    // в случае ошибки загрузить пустое изображение из ресурсов
                    Tk.PhotoTkan = Properties.Resources.tmp;
                }
                LstTkani.Add(Tk);  // добавить в список новую ткань
            }
            con.Close();
        }

        /// <summary>
        /// заполнение таблицы с фотографиями тканей
        /// </summary>
        void FillLVTkani()
        {
            LVTkani.Items.Clear();
            ImageListTkani.Images.Clear();
            foreach (Tkani Tk in LstTkani)
            {
                // новый элемент для ListView с названием ткани
                ListViewItem LV = new ListViewItem(Tk.NameTkan);
                // в ImageList добавить изображение ткани
                ImageListTkani.Images.Add(Tk.PhotoTkan);
                // связать последнее добавленное изображение с новым элементом ListView
                LV.ImageIndex = ImageListTkani.Images.Count - 1;
                LVTkani.Items.Add(LV);  // добавить новый элемент к ListView
            }
        }
        public struct Furnitura
        {
            public string IdFur, NameFur, CountFur;
            public Image PhotoFur;
        }

        List<Furnitura> LstFurnitura = new List<Furnitura>();

        /// <summary>
        /// получить данные о фурнитурах из базы данных
        /// </summary>
        void GetFurnituraFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.GarmentFactoryConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Furnitura where countfur > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Furnitura Fr = new Furnitura();
                Fr.IdFur = Data["idfur"].ToString();
                Fr.NameFur = Data["namefur"].ToString();
                Fr.CountFur = Data["countfur"].ToString();
                try
                {
                    // загрузить из таблицы БД байты фотографии в массив
                    byte[] PhotoByte = (byte[])Data["photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    // сконвертировать массив байт в изображение
                    Fr.PhotoFur = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    // в случае ошибки загрузить пустое изображение из ресурсов
                    Fr.PhotoFur = Properties.Resources.tmp;
                }
                LstFurnitura.Add(Fr);  // добавить в список новую фурнитуру
            }
            con.Close();
        }

        /// <summary>
        /// заполнить таблицу с фотографиями фурнитур
        /// </summary>
        void FillLVFurnitura()
        {
            LVFurnitura.Items.Clear();
            ImageListFur.Images.Clear();
            foreach (Furnitura Fr in LstFurnitura)
            {
                // новый элемент для ListView с названием фурнитуры
                ListViewItem LV = new ListViewItem(Fr.NameFur);
                // в ImageList добавить изображение фурнитуры
                ImageListFur.Images.Add(Fr.PhotoFur);
                // связать последнее добавленное изображение с новым элементом ListView
                LV.ImageIndex = ImageListFur.Images.Count - 1;
                LVFurnitura.Items.Add(LV);  // добавить новый элемент к ListView
            }
        }

        private void LVTkani_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVTkani.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVTkani.SelectedIndices[0];  // номер выделенного элемента
                NametkanTextBox.Text = LstTkani[num].NameTkan;
                ColorTextBox.Text = LstTkani[num].ColorTkan;
                WidthTextBox.Text = LstTkani[num].Width;
                LengthTextBox.Text = LstTkani[num].Length;
                DescriptionTextBox.Text = LstTkani[num].Description;
            }
            else  // нет выделенных элементов
            {
                NametkanTextBox.Text = "";
                ColorTextBox.Text = "";
                WidthTextBox.Text = "";
                LengthTextBox.Text = "";
                DescriptionTextBox.Text = "";
            }
        }

        private void LVFurnitura_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVFurnitura.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVFurnitura.SelectedIndices[0];  // номер выделенного элемента
                TbxNameFur.Text = LstFurnitura[num].NameFur;
                TbxCountFurSklad.Text = LstFurnitura[num].CountFur;
            }
            else  // нет выделенных элементов
            {
                TbxNameFur.Text = "";
                TbxCountFurSklad.Text = "";
            }
        }

        private void BtnProfile_Click(object sender, EventArgs e)
        {
            fProfile fProfile = new fProfile();
            // на форму для редактирования профиля передать 
            // фильтр для выборки авторизовавшегося пользователя
            fProfile.usersBindingSource.Filter = this.usersBindingSource.Filter;
            if (fProfile.ShowDialog() == DialogResult.OK)
            {
                this.usersTableAdapter.Fill(this.garmentFactoryDataSet.Users);
            }
        }

        private void BtnGetMaterial_Click(object sender, EventArgs e)
        {
            fGetMaterials fGetMaterials = new fGetMaterials();
            fGetMaterials.ShowDialog();
        }

        private void BtnSpisMaterial_Click(object sender, EventArgs e)
        {
            fWriteOff fWriteOff = new fWriteOff();
            fWriteOff.ShowDialog();
        }
    }
}
